#!/bin/bash

#export SWIFTC="`pwd`/../bin/swiftc"
export SWIFTC="/Users/rajbarik/workspace/swift-master-08052019/build/MyBuild/swift-macosx-x86_64/bin/swiftc"
#set -x
OUTPUT_FILE="table-5-size.txt"
> $OUTPUT_FILE


codesize() {
#  local sz="$(size -t $1 | tail -2 | head -1 | awk '{print $1,",",$2}')"
  local sz="$(size -m $1 | grep "__text" | awk '{print $3}')"
  echo "$sz"
}

compileExecute() {
  local FILENAME="$1.swift"
  # Baseline compile
  #echo "Baseline $FILENAME"
  xcrun $SWIFTC $2 $FILENAME
  BASELINE="$(codesize $1)"

  echo -n "Param "
  xcrun $SWIFTC $2 -Xfrontend -sil-existential-specializer $FILENAME 2>&1 > log.txt
  EXIST_PARAM="$(codesize $1)"
  #echo $EXIST_PARAM
  EXIST_PARAM_RATIO=`echo "scale=2; ${EXIST_PARAM} - ${BASELINE}" | bc`
  echo $EXIST_PARAM_RATIO

  echo -n "SoleType "
  xcrun $SWIFTC $2 -Xfrontend -sil-sole-type-propagation $FILENAME 2>&1 > log.txt
  EXIST_SOLE="$(codesize $1)"
  #echo $EXIST_SOLE
  EXIST_SOLE_RATIO=`echo "scale=2; ${EXIST_SOLE} - ${BASELINE}" | bc`
  echo $EXIST_SOLE_RATIO

  echo -n "LocalVar "
  xcrun $SWIFTC $2 -Xfrontend -sil-existential-value-specializer $FILENAME 2>&1 > log.txt
  EXIST_VALUE="$(codesize $1)"
  #echo $EXIST_VALUE
  EXIST_VALUE_RATIO=`echo "scale=2; ${EXIST_VALUE} - ${BASELINE}" | bc`
  echo $EXIST_VALUE_RATIO

  echo -n "Param+SoleType "
  xcrun $SWIFTC $2 -Xfrontend -sil-existential-specializer -Xfrontend -sil-sole-type-propagation $FILENAME 2>&1 > log.txt
  EXIST_PARAM_SOLE="$(codesize $1)"
  #echo $EXIST_PARAM_SOLE
  EXIST_PARAM_SOLE_RATIO=`echo "scale=2; ${EXIST_PARAM_SOLE} - ${BASELINE}" | bc`
  echo $EXIST_PARAM_SOLE_RATIO

  echo -n "Param+LocalVar "
  xcrun $SWIFTC $2 -Xfrontend -sil-existential-specializer -Xfrontend -sil-existential-value-specializer $FILENAME 2>&1 > log.txt
  EXIST_PARAM_VALUE="$(codesize $1)"
  #echo $EXIST_PARAM_VALUE
  EXIST_PARAM_VALUE_RATIO=`echo "scale=2; ${EXIST_PARAM_VALUE} - ${BASELINE}" | bc`
  echo $EXIST_PARAM_VALUE_RATIO

  echo -n "SoleType+LocalVar "
  xcrun $SWIFTC $2 -Xfrontend -sil-sole-type-propagation -Xfrontend -sil-existential-value-specializer $FILENAME 2>&1 > log.txt
  EXIST_SOLE_VALUE="$(codesize $1)"
  #echo $EXIST_SOLE_VALUE
  EXIST_SOLE_VALUE_RATIO=`echo "scale=2; ${EXIST_SOLE_VALUE} - ${BASELINE}" | bc`
  echo $EXIST_SOLE_VALUE_RATIO

  echo -n "Param+SoleType+LocalVar "
  xcrun $SWIFTC $2 -Xfrontend -sil-existential-specializer -Xfrontend -sil-sole-type-propagation -Xfrontend -sil-existential-value-specializer $FILENAME 2>&1 > log.txt
  EXIST_ALL="$(codesize $1)"
  #echo $EXIST_ALL
  EXIST_ALL_RATIO=`echo "scale=2; ${EXIST_ALL} - ${BASELINE}" | bc`
  echo $EXIST_ALL_RATIO

  #echo $1, $2, $BASELINE, $EXIST_PARAM, $EXIST_SOLE, $EXIST_VALUE, $EXIST_PARAM_SOLE, $EXIST_PARAM_VALUE, $EXIST_SOLE_VALUE, $EXIST_ALL
  echo "$1, $EXIST_PARAM_RATIO, $EXIST_SOLE_RATIO, $EXIST_VALUE_RATIO, $EXIST_PARAM_SOLE_RATIO, $EXIST_PARAM_VALUE_RATIO, $EXIST_SOLE_VALUE_RATIO, $EXIST_ALL_RATIO"
  echo "$1, $BASELINE, $EXIST_PARAM, $EXIST_SOLE, $EXIST_VALUE, $EXIST_PARAM_SOLE, $EXIST_PARAM_VALUE, $EXIST_SOLE_VALUE, $EXIST_ALL, $EXIST_ALL_RATIO" >> $OUTPUT_FILE
}

#export SDKROOT="/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.14.sdk"
export SDKROOT="/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.15.sdk"

declare -a files=("ArrayOfGenericRef" "ArrayOfRef" "Codable" "DictionarySubscriptDefault" "NSError" "ObserverForwarderStruct" "ObserverUnappliedMethod" "PopFrontGeneric" "ProtocolDispatch2" "SortLargeExistentials" "StackPromo" "StaticArray" "BucketSort")
echo "Benchmark | Param | SoleType | LocalVar | Param+SoleType | Param+LocalVar | SoleType+LocalVar | Param+SoleType+LocalVar | Diff"
for i in "${files[@]}"
do
compileExecute $i "-O -wmo"
done
